//+------------------------------------------------------------------+
//|                                                     megandle.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window

extern color UpCandle=Black;
extern color DnCandle=White;
extern color DojiColor=Blue;
extern bool  BGCandle=false;


string megandle;
int      name=0;
string   nameNewCandle,namePrevCandle;
string   nameNewShadowH,nameNewShadowL,namePrevShadowH,namePrevShadowL;
string   NameBar, NameHigh, NameLow;
int   Width=2;
int   CustomCandleTimeShift=2;

string savedopendate;
datetime TimeOpenNewBar,TimeCloseNewBar,TimeClosePrevBar;
datetime timeNewShadow,timePrevShadow;

//
int init()
  {

   return(0);
  }
//
int deinit()
  {

   for(int DelOBJ=1; DelOBJ<=name; DelOBJ++){
      ObjectDelete(NameBar+DelOBJ);
      ObjectDelete(NameHigh+DelOBJ);
      ObjectDelete(NameLow+DelOBJ);}
     
      Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   
double megandleOpen;
double megandleClose;

double normOpen;
double normClose;

normOpen=iOpen(NULL,0,1);
normClose=iClose(NULL,0,1);

//--------------------------------------------------------------------------------------------------------
int i;
megandleOpen=normOpen;

int counted_bars=IndicatorCounted();
i=Bars-IndicatorCounted();

//datetime StrToTime(string value) 
//Converts string in the format "yyyy.mm.dd hh:mi" to datetime type
datetime normOpenTime = iTime(NULL,0,1);
megandleOpen = iOpen(NULL,0, iBarShift(NULL,0,normOpenTime,false));

datetime normCloseTime = iTime(NULL,0,1);






// if current candle is bullish and previous candle was bullish, use the market price for megandle close
if ((MarketInfo(NULL,Bid)>MarketInfo(NULL,Open)) && (normClose-normOpen>0)) megandleClose=MarketInfo(NULL,Bid);
// if current candle is bullish and previous candle was bearish, use the previous candle close for megandle close
if ((MarketInfo(NULL,Bid)>MarketInfo(NULL,Open)) && (normClose-normOpen<0)) megandleClose=MarketInfo(NULL,Bid);
// if current candle is bearish and previous candle was bearish, use the market price for megandle close
if ((MarketInfo(NULL,Bid)<MarketInfo(NULL,Open)) && (normClose-normOpen<0)) megandleClose=MarketInfo(NULL,Bid);
// if current candle is bearish and previous candle was bullish, use the previous candle close for megandle close
if ((MarketInfo(NULL,Bid)<MarketInfo(NULL,Open)) && (normClose-normOpen>0)) megandleClose=MarketInfo(NULL,Bid);

//+------------------------------Create New Object & Modify Current--------------------------------+
while ((MarketInfo(NULL,Bid)>MarketInfo(NULL,Open)) && (normClose-normOpen>0))
   {  ObjectCreate(nameNewCandle,OBJ_RECTANGLE,0,normOpenTime,megandleOpen,normCloseTime,megandleClose);
      ObjectSet(nameNewCandle,OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(nameNewCandle,OBJPROP_COLOR, Black);
   }
   
while ((MarketInfo(NULL,Bid)>MarketInfo(NULL,Open)) && (normClose-normOpen<0))
   {  ObjectCreate(nameNewCandle,OBJ_RECTANGLE,0,normOpenTime,megandleOpen,normCloseTime,megandleClose);
      ObjectSet(nameNewCandle,OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(nameNewCandle,OBJPROP_COLOR, White);
   }
//----

      
   return(0);
  }

